#pragma once
#include "componentbasic.h"
#include <route_access.h>
#include <QHash>

/// <summary>
/// ·Դ
/// </summary>
struct RouteResource {
	QList<LonLatPos> _route_points;

	RouteResource& operator=(const RouteResource& other);
};

/// <summary>
/// ƽ·
/// </summary>
class COMPONENTBASIC_EXPORT PlainRouteManagePlugin : 
public RespondRoute<
	WsRespond<NewPlainRoute, RespondDefault>,
	WsRespond<RemovePlainRoute, RespondDefault>,
	WsRespond<PlainRouteReset, RespondDefault>,
	WsRespond<PlainRouteQuery, PlainRouteInfo>>,
public RequestRoute<>
{
private:
	std::weak_ptr<WsEntity> _bind_entity;
	QHash<QString, RouteResource> _route_resource_map;

public:
	PlainRouteManagePlugin();

	// ͨ ProcList ̳
	void execute(std::shared_ptr<const NewPlainRoute> in, QList<std::shared_ptr<RespondDefault>>& out) override;
	void execute(std::shared_ptr<const RemovePlainRoute> in, QList<std::shared_ptr<RespondDefault>>& out) override;
	void execute(std::shared_ptr<const PlainRouteReset> in, QList<std::shared_ptr<RespondDefault>>& out) override;
	void execute(std::shared_ptr<const PlainRouteQuery> in, QList<std::shared_ptr<PlainRouteInfo>>& out) override;

	void recoveryFrom(const QJsonObject& obj) override;
	void saveTo(QJsonObject& obj) const override;

	std::shared_ptr<Serializable> newDefault() const override;
	void bindEntity(std::weak_ptr<WsEntity> host) override;
	QString name() const override;
};

